#!/bin/sh
# rcrsn51 2023-05-12

echo
echo "Before starting, you must install two packages."
echo "apt install alsa-ucm-conf firmware-intel-sound"
echo "Then REBOOT."
read -p "Are you ready to start? [Y/n] " REPLY
[ "$REPLY" = "n" ] && exit
echo
echo "Here is a list of your sound cards:"
aplay -l | grep "card" | cut -d[ -f2 | cut -d] -f1 | uniq
echo
read -p "Enter the EXACT name of your UCM card: " CARD
[ -z "$CARD" ] && exit
aplay -l | grep "card" | grep -q -w "$CARD"
[ $? -gt 0 ] && echo "Card not found!" && exit
echo
echo "Here is a list of the audio devices on $CARD:"
alsaucm -c "$CARD" list _devices/HiFi | grep : | awk '{print $2}'
echo
echo "Enter the EXACT name of a device or press Enter to quit."
while true; do
  echo
  read -p "Device: " DEVICE
  [ -z "$DEVICE" ] && break
  echo "Setting up device $DEVICE on card $CARD ..."
  alsaucm -c "$CARD" set _verb HiFi set _enadev "$DEVICE"
  [ $? -eq 0 ] && echo "OK"
done
echo
echo "Run Sound Card Selector. Set $CARD as the default."
echo "Run alsamixer. Check that your device is unmuted (the M key)."
echo "Locate the volume setting on a control like DAC1."
echo
exit

#### some UCM or HDMI/LPE setups need the ALSA dmix control ###

#pcm.!default pcm.dmixer
#ctl.!default ctl.dmixer

pcm.dmixer {
  type plug
  slave.pcm {
    type dmix
    ipc_key 1024
    slave.pcm "hw:1,2"
  }
}

ctl.dmixer {
  type hw
  card 1
}

#### Keyboard volume keys > openbox --reconfigure ####

    <keybind key="XF86AudioRaiseVolume">
      <action name="Execute"> 
        <command>amixer set 'Speaker' 5%+</command>
      </action>
    </keybind>
    <keybind key="XF86AudioLowerVolume">
      <action name="Execute">
        <command>amixer set 'Speaker' 5%-</command>
      </action>
    </keybind>
    <keybind key="XF86AudioMute">
      <action name="Execute"> 
        <command>amixer set 'Speaker' toggle</command>
      </action>
    </keybind>
